From 3e405b6fd5db5615bbef241763de070118222ca7 Mon Sep 17 00:00:00 2001
From: Stefan Seefeld <stefan@seefeld.name>
Date: Thu, 9 Apr 2015 08:57:08 -0400
Subject: [PATCH] Fix exec_file for Python 3 < 3.4.

---
 src/exec.cpp | 7 +++++--
 1 file changed, 5 insertions(+), 2 deletions(-)

diff --git a/src/exec.cpp b/src/exec.cpp
index 2910db7..12cdabc 100644
--- a/src/exec.cpp
+++ b/src/exec.cpp
@@ -86,9 +86,12 @@ object BOOST_PYTHON_DECL exec_file(str filename, object global, object local)
   char *f = python::extract<char *>(filename);
 
   // Let python open the file to avoid potential binary incompatibilities.
-#if PY_VERSION_HEX >= 0x03000000
-  // See http://www.codeproject.com/Articles/820116/Embedding-Python-program-in-a-C-Cplusplus-code
+#if PY_VERSION_HEX >= 0x03400000
   FILE *fs = _Py_fopen(f, "r");
+#elif PY_VERSION_HEX >= 0x03000000
+  PyObject *fo = Py_BuildValue("s", f);
+  FILE *fs = _Py_fopen(fo, "r");
+  Py_DECREF(fo);
 #else
   PyObject *pyfile = PyFile_FromString(f, const_cast<char*>("r"));
   if (!pyfile) throw std::invalid_argument(std::string(f) + " : no such file");
-- 
2.1.0

